fork: report pid reservation failure properly
[linux-2.6-block.git] / scripts / kconfig / Makefile
CommitLineData
1da177e4
LT
1# ===========================================================================
2# Kernel configuration targets
3# These targets are used from top-level makefile
4
1cba0c30 5PHONY += xconfig gconfig menuconfig config silentoldconfig update-po-config \
281c9dad 6 localmodconfig localyesconfig
1da177e4 7
61bee204
AV
8ifdef KBUILD_KCONFIG
9Kconfig := $(KBUILD_KCONFIG)
10else
838a2e55 11Kconfig := Kconfig
61bee204 12endif
e703f75d 13
0a1f00a1
MM
14ifeq ($(quiet),silent_)
15silent := -s
16endif
17
c2838e6e
YM
18# We need this, in case the user has it in its environment
19unexport CONFIG_
20
1da177e4 21xconfig: $(obj)/qconf
0a1f00a1 22 $< $(silent) $(Kconfig)
1da177e4
LT
23
24gconfig: $(obj)/gconf
0a1f00a1 25 $< $(silent) $(Kconfig)
1da177e4
LT
26
27menuconfig: $(obj)/mconf
0a1f00a1 28 $< $(silent) $(Kconfig)
1da177e4
LT
29
30config: $(obj)/conf
0a1f00a1 31 $< $(silent) --oldaskconfig $(Kconfig)
1da177e4 32
692d97c3 33nconfig: $(obj)/nconf
0a1f00a1 34 $< $(silent) $(Kconfig)
692d97c3 35
1da177e4 36silentoldconfig: $(obj)/conf
9815594a 37 $(Q)mkdir -p include/config include/generated
0a1f00a1 38 $< $(silent) --$@ $(Kconfig)
1da177e4 39
50bce3e8 40localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
9815594a 41 $(Q)mkdir -p include/config include/generated
22d550ae 42 $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
7a996d3a 43 $(Q)if [ -f .config ]; then \
4062f1a4
SR
44 cmp -s .tmp.config .config || \
45 (mv -f .config .config.old.1; \
46 mv -f .tmp.config .config; \
0a1f00a1 47 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
4062f1a4
SR
48 mv -f .config.old.1 .config.old) \
49 else \
50 mv -f .tmp.config .config; \
0a1f00a1 51 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
a7c02602 52 fi
03fa25da
SR
53 $(Q)rm -f .tmp.config
54
1020026f 55# Create new linux.pot file
b70e325c 56# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
46d26319 57update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
0a1f00a1 58 $(Q)$(kecho) " GEN config.pot"
a24a1b8e
PF
59 $(Q)xgettext --default-domain=linux \
60 --add-comments --keyword=_ --keyword=N_ \
61 --from-code=UTF-8 \
62 --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
63 --directory=$(srctree) --directory=$(objtree) \
b70e325c
SR
64 --output $(obj)/config.pot
65 $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
fa0ad657
PB
66 $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
67 $(srctree)/arch/*/um/Kconfig`; \
1020026f 68 do \
0a1f00a1 69 $(kecho) " GEN $$i"; \
4217516e 70 $(obj)/kxgettext $$i \
1020026f
EG
71 >> $(obj)/config.pot; \
72 done )
0a1f00a1 73 $(Q)$(kecho) " GEN linux.pot"
1020026f 74 $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
b70e325c 75 --output $(obj)/linux.pot
b70e325c 76 $(Q)rm -f $(obj)/config.pot
3b9fa093 77
1cba0c30
MM
78# These targets map 1:1 to the commandline options of 'conf'
79simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
80 alldefconfig randconfig listnewconfig olddefconfig
81PHONY += $(simple-targets)
1da177e4 82
1cba0c30 83$(simple-targets): $(obj)/conf
0a1f00a1 84 $< $(silent) --$@ $(Kconfig)
1da177e4 85
1cba0c30 86PHONY += oldnoconfig savedefconfig defconfig
1da177e4 87
fb16d891
AL
88# oldnoconfig is an alias of olddefconfig, because people already are dependent
89# on its behavior(sets new symbols to their default value but not 'n') with the
90# counter-intuitive name.
1cba0c30 91oldnoconfig: olddefconfig
fb16d891 92
7cf3d73b 93savedefconfig: $(obj)/conf
0a1f00a1 94 $< $(silent) --$@=defconfig $(Kconfig)
7cf3d73b 95
1da177e4
LT
96defconfig: $(obj)/conf
97ifeq ($(KBUILD_DEFCONFIG),)
0a1f00a1 98 $< $(silent) --defconfig $(Kconfig)
1da177e4 99else
0a1f00a1
MM
100 @$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
101 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
1da177e4
LT
102endif
103
104%_defconfig: $(obj)/conf
0a1f00a1 105 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
1da177e4 106
63a91033 107configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
3aaefce1 108
63a91033
MY
109%.config: $(obj)/conf
110 $(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
111 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
112 +$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
3aaefce1
JT
113
114PHONY += kvmconfig
63a91033
MY
115kvmconfig: kvm_guest.config
116 @:
3aaefce1 117
0da1d4a0 118PHONY += tinyconfig
63a91033
MY
119tinyconfig:
120 $(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
0da1d4a0 121
1da177e4
LT
122# Help text used by make help
123help:
124 @echo ' config - Update current config utilising a line-oriented program'
692d97c3 125 @echo ' nconfig - Update current config utilising a ncurses menu based program'
1da177e4
LT
126 @echo ' menuconfig - Update current config utilising a menu based program'
127 @echo ' xconfig - Update current config utilising a QT based front-end'
128 @echo ' gconfig - Update current config utilising a GTK based front-end'
129 @echo ' oldconfig - Update current config utilising a provided .config as base'
03fa25da 130 @echo ' localmodconfig - Update current config disabling modules not loaded'
281c9dad 131 @echo ' localyesconfig - Update current config converting local mods to core'
590a5857 132 @echo ' silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
0748cb3e 133 @echo ' defconfig - New config with default from ARCH supplied defconfig'
7cf3d73b 134 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
e11f0496 135 @echo ' allnoconfig - New config where all options are answered with no'
0748cb3e
SR
136 @echo ' allyesconfig - New config where all options are accepted with yes'
137 @echo ' allmodconfig - New config selecting modules when possible'
138 @echo ' alldefconfig - New config with all symbols set to default'
139 @echo ' randconfig - New config with random answer to all options'
861b4ea4 140 @echo ' listnewconfig - List new options'
fb16d891 141 @echo ' olddefconfig - Same as silentoldconfig but sets new symbols to their default value'
3aaefce1 142 @echo ' kvmconfig - Enable additional options for guest kernel support'
0da1d4a0 143 @echo ' tinyconfig - Configure the tiniest possible kernel'
1da177e4 144
2982de69
SR
145# lxdialog stuff
146check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
147
e9e40e14 148# Use recursively expanded variables so we do not call gcc unless
2982de69 149# we really need to do so. (Do not call gcc as part of make mrproper)
9ba95682
AL
150HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
151 -DLOCALE
2982de69 152
1da177e4
LT
153# ===========================================================================
154# Shared Makefile for the various kconfig executables:
155# conf: Used for defconfig, oldconfig and related targets
692d97c3 156# nconf: Used for the nconfig target.
157# Utilizes ncurses
6f26e5e4 158# mconf: Used for the menuconfig target
1da177e4
LT
159# Utilizes the lxdialog package
160# qconf: Used for the xconfig target
161# Based on QT which needs to be installed to compile it
162# gconf: Used for the gconfig target
163# Based on GTK which needs to be installed to compile it
164# object files used by all kconfig flavours
165
2982de69
SR
166lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
167lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
168
1da177e4 169conf-objs := conf.o zconf.tab.o
692d97c3 170mconf-objs := mconf.o zconf.tab.o $(lxdialog)
171nconf-objs := nconf.o zconf.tab.o nconf.gui.o
3b9fa093 172kxgettext-objs := kxgettext.o zconf.tab.o
f1943049 173qconf-cxxobjs := qconf.o
5a6f8d2b
AL
174qconf-objs := zconf.tab.o
175gconf-objs := gconf.o zconf.tab.o
1da177e4 176
022af62d 177hostprogs-y := conf nconf mconf kxgettext qconf gconf
1da177e4 178
5a6f8d2b 179clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
2f76b358 180clean-files += zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
1020026f 181clean-files += config.pot linux.pot
1da177e4 182
6e588f6d
SR
183# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
184PHONY += $(obj)/dochecklxdialog
185$(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
186$(obj)/dochecklxdialog:
7080e47b 187 $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
6e588f6d
SR
188
189always := dochecklxdialog
190
aa1e5ef5
SR
191# Add environment specific flags
192HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
70a6a0cb 193
1da177e4 194# generated files seem to need this to find local include files
2f76b358 195HOSTCFLAGS_zconf.lex.o := -I$(src)
1da177e4
LT
196HOSTCFLAGS_zconf.tab.o := -I$(src)
197
378dbb2c
AL
198LEX_PREFIX_zconf := zconf
199YACC_PREFIX_zconf := zconf
200
5a6f8d2b
AL
201HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
202HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
1da177e4 203
5a6f8d2b 204HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
37193147 205HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
1ea3ad4e 206 -Wno-missing-prototypes
1da177e4 207
7080e47b
AL
208HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
209
544e7e54 210HOSTLOADLIBES_nconf = $(shell \
7285996a
BN
211 pkg-config --libs menuw panelw ncursesw 2>/dev/null \
212 || pkg-config --libs menu panel ncurses 2>/dev/null \
544e7e54 213 || echo "-lmenu -lpanel -lncurses" )
1da177e4
LT
214$(obj)/qconf.o: $(obj)/.tmp_qtcheck
215
022af62d 216ifeq ($(MAKECMDGOALS),xconfig)
b3a5225f 217$(obj)/.tmp_qtcheck: $(src)/Makefile
1da177e4
LT
218-include $(obj)/.tmp_qtcheck
219
220# QT needs some extra effort...
221$(obj)/.tmp_qtcheck:
0a1f00a1 222 @set -e; $(kecho) " CHECK qt"; dir=""; pkg=""; \
133c5f7c
AS
223 if ! pkg-config --exists QtCore 2> /dev/null; then \
224 echo "* Unable to find the QT4 tool qmake. Trying to use QT3"; \
225 pkg-config --exists qt 2> /dev/null && pkg=qt; \
226 pkg-config --exists qt-mt 2> /dev/null && pkg=qt-mt; \
227 if [ -n "$$pkg" ]; then \
228 cflags="\$$(shell pkg-config $$pkg --cflags)"; \
229 libs="\$$(shell pkg-config $$pkg --libs)"; \
230 moc="\$$(shell pkg-config $$pkg --variable=prefix)/bin/moc"; \
231 dir="$$(pkg-config $$pkg --variable=prefix)"; \
232 else \
233 for d in $$QTDIR /usr/share/qt* /usr/lib/qt*; do \
234 if [ -f $$d/include/qconfig.h ]; then dir=$$d; break; fi; \
235 done; \
236 if [ -z "$$dir" ]; then \
5b580fa6
MM
237 echo >&2 "*"; \
238 echo >&2 "* Unable to find any QT installation. Please make sure that"; \
239 echo >&2 "* the QT4 or QT3 development package is correctly installed and"; \
240 echo >&2 "* either qmake can be found or install pkg-config or set"; \
241 echo >&2 "* the QTDIR environment variable to the correct location."; \
242 echo >&2 "*"; \
133c5f7c
AS
243 false; \
244 fi; \
245 libpath=$$dir/lib; lib=qt; osdir=""; \
246 $(HOSTCXX) -print-multi-os-directory > /dev/null 2>&1 && \
247 osdir=x$$($(HOSTCXX) -print-multi-os-directory); \
248 test -d $$libpath/$$osdir && libpath=$$libpath/$$osdir; \
249 test -f $$libpath/libqt-mt.so && lib=qt-mt; \
250 cflags="-I$$dir/include"; \
251 libs="-L$$libpath -Wl,-rpath,$$libpath -l$$lib"; \
252 moc="$$dir/bin/moc"; \
253 fi; \
254 if [ ! -x $$dir/bin/moc -a -x /usr/bin/moc ]; then \
255 echo "*"; \
256 echo "* Unable to find $$dir/bin/moc, using /usr/bin/moc instead."; \
257 echo "*"; \
258 moc="/usr/bin/moc"; \
259 fi; \
ab919c06 260 else \
458452f4
MM
261 cflags="\$$(shell pkg-config QtCore QtGui Qt3Support --cflags)"; \
262 libs="\$$(shell pkg-config QtCore QtGui Qt3Support --libs)"; \
48485949
YS
263 moc="\$$(shell pkg-config QtCore --variable=moc_location)"; \
264 [ -n "$$moc" ] || moc="\$$(shell pkg-config QtCore --variable=prefix)/bin/moc"; \
b3a5225f
RZ
265 fi; \
266 echo "KC_QT_CFLAGS=$$cflags" > $@; \
267 echo "KC_QT_LIBS=$$libs" >> $@; \
268 echo "KC_QT_MOC=$$moc" >> $@
1da177e4
LT
269endif
270
271$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
272
022af62d 273ifeq ($(MAKECMDGOALS),gconfig)
1da177e4
LT
274-include $(obj)/.tmp_gtkcheck
275
276# GTK needs some extra effort, too...
277$(obj)/.tmp_gtkcheck:
37193147
AB
278 @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
279 if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
1da177e4
LT
280 touch $@; \
281 else \
5b580fa6
MM
282 echo >&2 "*"; \
283 echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
284 echo >&2 "*"; \
1da177e4
LT
285 false; \
286 fi \
287 else \
5b580fa6
MM
288 echo >&2 "*"; \
289 echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
290 echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
291 echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
292 echo >&2 "*"; \
1da177e4
LT
293 false; \
294 fi
295endif
296
2f76b358 297$(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
1da177e4 298
5a6f8d2b 299$(obj)/qconf.o: $(obj)/qconf.moc
1da177e4 300
ebca026a
YS
301quiet_cmd_moc = MOC $@
302 cmd_moc = $(KC_QT_MOC) -i $< -o $@
303
304$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
305 $(call cmd,moc)
1da177e4 306
46d26319
EG
307# Extract gconf menu items for I18N support
308$(obj)/gconf.glade.h: $(obj)/gconf.glade
2d80eb0f 309 $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
a24a1b8e 310 $(obj)/gconf.glade